'FFSubmenu=IPTC
'FFName=KeyWords

' #####################################################################
' Script zur Eingabe von KeyWords in IPTC-Daten und Suche nach Bildern mit vorgegeben Keywords
'
'
' Version 2.11	- 29.03.2016 - Skript-URL gem Forenberarbeitung gendert
' Version 2.10  - 07.11.2015 - Mit 'S' fr S(uchen) bzw. mit Tastenkombination Alt & S wird
'								bei teilweiser Eingabe eines Keywords auf die Keywordliste gesprungen
' Version 2.09  - 20.09.2015 - Mit 'KW Kopieren' knnen die in der Einzelbearbeitung angezeigten
'								Keywords in die Aktivliste kopiert werden
'							 - Tooltippfehler bei 'KW Lschen' korrigiert
'								Es werden immer alle Keywords gelscht
'							 - Bug beim Lschen einzelner Keywords in der Einzelbearbeitung behoben
'							 - Bug bei bertragung einer Eingabe in die Aktivliste whrend 
'								des Eintrags einer Eingabe in die Passivliste
'							 - Kurzbeschreibung wird jetzt als PDF-Dokument angezeigt
' Version 2.08  - 16.09.2015 - Ausblendung fehlerhafter Bilder verbessert
'							 - bei Einzelbearbeitung auch Lschen eines einzigen Keyword mglich
'							 - Umbenennungen aller Benennungen mit IPTC auf KW (Keyword)
'							 - Update-Funktion eingebaut
'							 - Tooltipps eingetragen
'						     - weitere kleine Verbesserungen
'							 - Kategorie gendert von Exif/IPTC auf IPTC
' Version 2.07	- 10.07.2009 - Lschroutine hinzugefgt und KB entsprechend ergnzt
' Version 2.06	- 29.01.2009 - Austausch Aktiv-Passivliste mit Doppelklick
' Version 2.05	- 11.01.2009 - Kontrolle auf FF-Umgebung
'							   Bug bei Doppelklick in Liste beseitigt
' Version 2.04	- 24.08.2008 - Bug 'wenn kein Bild selektiert' beseitigt
' Version 2.03	- 29.06.2008 - Sicherh.Abfr. Speichern wenn Passivliste gendert wurde
' Version 2.02	- 22.06.2008 - Funde in Bilder- und Verz.-Liste ablegen
' Version 2.01	- 16.06.2008 - Einzelbildbearbeitung umgestellt auf sel. Bilder
' Version 2.00	- 12.06.2008 - Selektion vernderbar bei laufendem Skript
' Version 1.01	- 10.06.2008 - Einzelbildeintrag
' Version 1.00	- 19.05.2008 - Betaversion
'
' (c) Harald Maeckler
' #####################################################################

'** Start Kurzbeschreibung ********************************************
' KeyWords / Version 2.11
' ===============
' Keywords sind Schlsselwrter, die in den IPTC-Daten eines JPG- oder TIF-Bildes abgespeichert werden knnen. Es sind 
' beliebig viele mglich mit jeweils maximaler Lnge von 64 Zeichen (incl. Leerzeichen) nur begrenzt durch die maximal
' zulssige Gre des gesamten IPTC-Dateikopfes von 64 KB.
'
' Das vorliegende FF-Skript dient dazu, Keywords in ausgewhlten Bildern abzulegen und nach Bildern mit vorgegeben 
' Keywords zu suchen.
'
' Bilderauswahl
' -----------------
' Hier wird festgelegt, welche Bilder bearbeitet werden sollen. Die Auswahl kann bei laufendem Skript gendert werden.
'
' Einzelbearbeitung selektierter Bilder
' --------------------------------------------
' Die Einzelbearbeitung bezieht sich unabhngig von der Bilderauswahl, auf die gerade selektierten Bilder im Computer-
' verzeichnis. Auch hier kann die Selektion bei laufendem Skript gendert werden. Nach nderung der Markierung gengt 
' ein Mausklick auf das gezeigte Bild und das erste der selektierten Bilder wird mit Angabe des Bildernamen und der 
' Auflistung im Bild abgelegter Keywords angezeigt.
'
' Mit den Pfeilen < und > kann innerhalb des Selektionsbereichs geblttert werden.
'
' Das Lschen aller Keywords im angezeigten Bild ist mit "KW Lschen" mglich.
' Soll nur ein Keyword aus der angezeigten Liste gelscht werden, muss die Option "<< Lschen" aktiviert und dann
' das zu lschende Keyword doppelt angeklickt werden.
'
' Neue Keywords knnen mit "KW Eintragen" hinzugefgt werden. Dazu mssen in der Aktivliste die entsprechenden 
' Begriffe eingetragen sein.
'
' Die angezeigten Keywords knnen mit "KW Kopieren" in die Aktivliste bertragen werden.
'
' Keywords
' ------------
' Es wird zwischen einer Passiv- und einer Aktivliste unterschieden. In der Passivliste werden die bisher verwendeten 
' Keywords angezeigt, in der Aktivliste werden die einzutragenden bzw. zu suchenden Keywords aufgelistet.
'
' Es sollten mglichst immer die gleichen Keywords in gleicher Schreibweise verwendet werden. Wird das  Skript zum 
' ersten Mal benutzt, ist es sinnvoll, den Bildbestand nach vorhandenen Keywords mit dem Befehl "Sammeln" durchsu-
' chen zu lassen. Das kann natrlich lange dauern, aber belohnt wird man mit der Auflistung aller jemals benutzten 
' Keywords in der Aktivliste. Diese bertrgt man alle mit "<<" in die Passivliste und bettigt "Speichern". Damit
' werden alle Keywords der Passivliste alphabetisch sortiert und in der Datei KeyWords_IPTC.txt im FF-Skriptver-
' zeichnis gesichert.
'
' Neue Keywords werden in die Passivliste oben eingegeben und mit Klick auf "v" am Ende der Passiv- und der Aktivliste
' eingetragen. In der Textdatei wird der neue Begriff mit "Speichern" hinzugefgt. Gleichzeitig wird er alphanumerisch
' in die Passivliste einsortiert.
' Bei teilweiser Eingabe eines Begriffs wird durch Mausklick auf 'S' oder die Tastenkombination 'Alt' & 'S' auf den ersten
' Begriff der Passivliste gesprungen, der der bisherigen Eingabe entspricht. Klein- bzw. Groschreibung spielt dabei keine
' Rolle.
'
' Mit "Restaurieren" werden die gesicherten Keywords alphabetisch sortiert in die Passivliste eingetragen. Doppeleintrge
' werden vermieden.
'
' Vor dem Eintragen oder Suchen von Keywords mssen Begriffe aus der Passivliste mit ">" oder Doppelklick in die Aktivliste
' bertragen werden. Das Eintragen gem Bilderauswahl erfolgt mit "KW Eintragen". Das Lschen aller Keywords gem
' Bilderauswahl ist mit "KW Lschen" mglich.
'
' Die in der Aktivliste eingetragenen Keywords knnen einzeln entfernt werden durch Doppelklick auf das zu lschende Keyword
' oder durch Markieren und dann Anklicken von "Lschen" oder "<".
' Alle entfernen kann man mit Klick auf "Alles Lschen" oder "<<".
'
' In IPTC-Daten suchen
' ---------------------------
' Die bei der IPTC-Suche gefundenen Bilder werden in einer Bilderliste oder einer Verzeichnisliste abgelegt. Eine vorhandene 
' Liste wird durch Mausklick in der Auflistung ausgewhlt. Mit Klick auf "Neu" kann auch eine neue Bilder- oder Verzeichnis-
' liste angelegt werden.
' Vor der Suche mit Klick auf "KW Suchen" muss man sich entscheiden, ob alle Begriffe (UND-verknpfung) vorhanden sein
' mssen oder ob einer der Begriffe (ODER-Verknpfung) ausreicht.
'
' Diverses
' ----------
' Mit "?" wird die vorliegende Erluterung angezeigt.
' Mit "Update" wird geprft, ob eine neue Version im Zubehrbereich des FF-Forums abgelegt ist.
' Mit "Schlieen" wird das Skript beendet.
'
' Deinstallation
' ========
' Wird die Entfernung des Skripts gewnscht, kann mit der Tastenkombination Alt + D eine Lschroutine aufgerufen werden.
' Nach einer Sicherheitsabfrage wird berprft, ob das zugehrige zip-Archiv im Skriptordner abgelegt ist. Wenn ja, wird
' vor dem Lschen angeboten, davon eine Sicherheitskopie an einem beliebigen Speicherort abzulegen. Danach werden nach-
' einander die Skriptdatei, die in der Registry dazugehrenden Daten und eventuelle Zusatzdateien gelscht. Abschlieend 
' wird die FixFotoScript.ini bereinigt.
' Nach manueller Durchfhrung einer 'Automatischen Skriptkonfiguration' ist das Skript mit allen Komponenten aus der
' FixFoto-Umgebung entfernt.
'
'
' Benutzung des Skripts auf eigene Gefahr!
'
' Copyright Harald Maeckler
'** Ende Kurzbeschreibung *********************************************

Option Explicit

const SkriptName = "KeyWords.vbs"				'Skriptname
Dim Kurzbeschreibung, KBvorhanden, LaengeMax	'Kurzbeschreibung

'Updatekonstanten und Variable
const SkriptVersion = "2.11"
const SkriptURL = "http://www.ffsf.de/resources/keywords.155/"
Dim UrlVersion,UrlV_Zahl,SkriptV_Zahl,SkriptEnde

Dim Antwort,imagecount,SkriptKill,TempFile
Dim objFS, WshShell, objFolder, objsubfolder, objFile, Bild
Dim AuswahlWert, Auswahl(2), Anzahl, Gesamtanzahl
Const BildKenn = "JPG-JPEG-TIF"							'Bildfilter

Dim Eingabe, PassivListe, AktivListe,KWvorhandenListe
Dim Feld(), Feldzahl, Pos
Dim KeyWordDatei, DateiName, SuchUndWert, BilderListenWert, KeinBildD,KeinBildDalt
Dim BearbeitungsFlag									'0= Sammeln, 1= Lschen, 2= Eintragen, 3= Suchen
Dim LInhalt, Wert, FeldZahlAktiv,flag_Loesch
const KWDatei = "KeyWords_IPTC.txt", ForReading = 1, ForWriting = 2
const KBDatei = "KeyWord_KeinBild.jpg"
Dim Bilder, ListeBilder, Abbruch, LVorhanden, Fundzahl
Dim SelBilder, SelListeBilder, SelAnzahl, SelZaehler, SelBildAktiv
Dim BildListeAktiv, PassivAlt, PLflag

'------------------------------------------------------------------------
call Main
'------------------------------------------------------------------------
Sub Main

on error resume next									'Kontrolle ob Skript in FF-Umgebung gestartet wurde
	imagecount = FF_GetImageCount
 	if Err.Number = 500 then
		msgbox "Das Skript funktioniert nur in der Programmumgebung von FixFoto!",vbCritical,"Abbruch"
		exit sub
	end if
on error goto 0

'** Start Dialog KeyWords **
FF_AddDialog "KeyWords",242,260
FF_AddControl "KeyWords","Bilderauswahl","GROUP",8,8,104,40
FF_AddControl "KeyWords","selBilder","BOOL",12,18,9,8
FF_SetControlStyle "KeyWords","selBilder",16384
FF_AddControl "KeyWords","selektierte Bilder","STATIC",22,17,64,10
FF_AddControl "KeyWords","allBilder","BOOL",12,28,8,8
FF_SetControlStyle "KeyWords","allBilder",16384
FF_AddControl "KeyWords","alle Bilder im Verzeichnis","STATIC",22,27,64,10
FF_AddControl "KeyWords","allBilderUV","BOOL",12,38,8,8
FF_SetControlStyle "KeyWords","allBilderUV",16384
FF_AddControl "KeyWords","alle Bilder incl. Unterverzeichnisse","STATIC",22,37,84,10
FF_AddControl "KeyWords","Einzelbearbeitung selektierter Bilder","GROUP",8,51,104,152
FF_AddControl "KeyWords","ImageAktiv","IMAGE",13,59,94,68
FF_AddControl "KeyWords","||<","BUTTON",14,130,11,11
FF_AddControl "KeyWords","ImageGeladen","SLEDIT",28,131,65,10
FF_SetControlStyle "KeyWords","ImageGeladen",2049
FF_AddControl "KeyWords","||>","BUTTON",95,131,11,11
FF_AddControl "KeyWords","KWvorhanden","LISTBOX",14,146,46,42
FF_AddControl "KeyWords","||KW Lschen","BUTTON",64,145,41,11
FF_AddControl "KeyWords","<< Lschen","STATIC",65,160,32,10
FF_AddControl "KeyWords","flag_Loesch","BOOL",97,161,8,8
FF_AddControl "KeyWords","aus Aktivliste","STATIC",65,171,34,9
FF_AddControl "KeyWords","||KW Eintragen","BUTTON",64,180,42,9
FF_AddControl "KeyWords","|>","STATIC",112,26,8,11
FF_AddControl "KeyWords","Keywords","GROUP",119,7,116,164
FF_AddControl "KeyWords","Passivliste","STATIC",129,15,33,11
FF_SetControlStyle "KeyWords","Passivliste",1
FF_AddControl "KeyWords","EingbabeKW","SLEDIT",126,27,41,10
FF_AddControl "KeyWords","v","BUTTON",135,39,11,11
FF_AddControl "KeyWords","PassivListe","LISTBOX",126,52,41,58
FF_AddControl "KeyWords","Lschen","BUTTON",126,112,41,11
FF_AddControl "KeyWords","Alles Lschen","BUTTON",126,125,41,11
FF_AddControl "KeyWords","Speichern","BUTTON",126,142,41,11
FF_AddControl "KeyWords","Restaurieren","BUTTON",126,155,41,11
FF_AddControl "KeyWords",">","BUTTON",171,58,11,11
FF_AddControl "KeyWords","<","BUTTON",171,73,11,11
FF_AddControl "KeyWords","<<","BUTTON",171,84,11,11
FF_AddControl "KeyWords","Aktivliste","STATIC",188,16,33,11
FF_SetControlStyle "KeyWords","Aktivliste",1
FF_AddControl "KeyWords","Sammeln","BUTTON",186,27,41,11
FF_AddControl "KeyWords","|v","STATIC",191,39,33,11
FF_SetControlStyle "KeyWords","|v",1
FF_AddControl "KeyWords","AktivListe","LISTBOX",186,52,41,58
FF_AddControl "KeyWords","|Lschen","BUTTON",186,112,41,11
FF_AddControl "KeyWords","|Alles Lschen","BUTTON",186,125,41,11
FF_AddControl "KeyWords","KW Lschen","BUTTON",186,142,41,11
FF_AddControl "KeyWords","KW Eintragen","BUTTON",186,155,41,11
FF_AddControl "KeyWords","In IPTC-Daten suchen","GROUP",119,173,116,80
FF_AddControl "KeyWords","Ablage in:","STATIC",122,186,28,10
FF_AddControl "KeyWords","boolBListe","BOOL",163,183,8,8
FF_SetControlStyle "KeyWords","boolBListe",16384
FF_AddControl "KeyWords","Bilderliste","STATIC",157,191,24,10
FF_AddControl "KeyWords","boolVListe","BOOL",204,183,8,8
FF_SetControlStyle "KeyWords","boolVListe",16384
FF_AddControl "KeyWords","Verzeichnisliste","STATIC",191,191,38,9
FF_AddControl "KeyWords","FundListe","COMBO",8,205,205,11
FF_AddControl "KeyWords","Neu","BUTTON",214,205,18,11
FF_AddControl "KeyWords","boolSucheUnd","BOOL",126,231,8,8
FF_SetControlStyle "KeyWords","boolSucheUnd",16384
FF_AddControl "KeyWords","mit allen Begriffen","STATIC",136,230,44,11
FF_AddControl "KeyWords","boolSucheOder","BOOL",126,241,8,8
FF_SetControlStyle "KeyWords","boolSucheOder",16384
FF_AddControl "KeyWords","mit einem Begriff","STATIC",136,240,45,11
FF_AddControl "KeyWords","KW Suchen","BUTTON",186,235,41,11
FF_AddControl "KeyWords","?","BUTTON",7,240,11,11
FF_AddControl "KeyWords","Schlieen","BUTTON",82,240,33,11
FF_AddControl "KeyWords","&d","BUTTON",0,0,1,1
FF_AddControl "KeyWords","Fortschritt","PROGRESS",4,219,236,4
FF_AddControl "KeyWords","Abbruch mit ","STATIC",21,224,31,10
FF_AddControl "KeyWords","|","STATIC",20,240,24,11
FF_SetControlStyle "KeyWords","|",1
FF_AddControl "KeyWords","Update","BUTTON",46,240,33,11
FF_AddControl "KeyWords","Backspace","BUTTON",51,225,33,8
FF_AddControl "KeyWords","-Taste","STATIC",85,224,18,10
FF_AddControl "KeyWords","KW Kopieren","BUTTON",16,191,42,9
FF_AddControl "KeyWords","in die Aktivliste","STATIC",66,191,42,9
FF_AddControl "KeyWords","&S","BUTTON",150,39,11,11
'** End Dialog KeyWords **

Set objFS = CreateObject("Scripting.FileSystemObject")
Set WshShell = CreateObject("WScript.Shell")
DateiName = FF_GetScriptPath() & "\" & KWDatei				'Datei mit den Keywords
KeinBildD = FF_GetScriptPath() & "\MeckiScript\Keywords\" & KBDatei	'Datei mit Meldebild

KeinBildDalt = FF_GetScriptPath() & "\" & KBDatei			'bis incl. Version 2.08
if objFS.FileExists(KeinBildDalt) then objFS.DeleteFile KeinBildDalt,true

call RegistryLesen
call Lesen
call EinzelBildBearbeitung (0)

Eingabe = ""
if BilderListenWert = "1" then
	call Bilderliste
else
	call Verzeichnisliste
end if

'Tooltipps
if Version_OK("3.30.06") then
	FF_SetControlTooltip "KeyWords","Sammeln", "" &_
					 	 "Die nach Bilderauswahl gewhlten Bilder werden" & vbNewLine &_
					 	 "nach Keywords durchsucht und die gefundenen" & vbNewLine &_
					 	 "Keywords werden in der Aktivliste angezeigt."
	FF_SetControlTooltip "KeyWords","v", "" &_
					 	 "Das oben eingetragene Keyword wird" & vbNewLine &_
					 	 "wird in die Passiv- und Aktivliste eingetragen."
	FF_SetControlTooltip "KeyWords",">", "" &_
					 	 "Das markierte Keyword wird in die" & vbNewLine &_
					 	 "Passivliste eingetragen."
	FF_SetControlTooltip "KeyWords","<", "" &_
					 	 "Das markierte Keyword wird zur Aktivliste" & vbNewLine &_
					 	 "verschoben und in der Passivliste gelscht."
	FF_SetControlTooltip "KeyWords","<<", "" &_
					 	 "Alle Keywords werden zur Aktivliste" & vbNewLine &_
					 	 "verschoben und in der Passivliste gelscht."
	FF_SetControlTooltip "KeyWords","Lschen", "" &_
					 	 "Das markierte Keyword wird in der Passivliste gelscht."
	FF_SetControlTooltip "KeyWords","Alles Lschen", "" &_
					 	 "Alle Keywords werden in der Passivliste gelscht."
	FF_SetControlTooltip "KeyWords","Speichern", "" &_
					 	 "Alle in der Passivliste eingetragenen" & vbNewLine &_
					 	 "Keywords werden gesichert."
	FF_SetControlTooltip "KeyWords","Restaurieren", "" &_
					 	 "Alle gesicherten Keywords werden" & vbNewLine &_
					 	 "in die Passivliste eingetragen."
	FF_SetControlTooltip "KeyWords","|Lschen", "" &_
					 	 "Das markierte Keyword wird in der Aktivliste gelscht."
	FF_SetControlTooltip "KeyWords","|Alles Lschen", "" &_
					 	 "Alle Keywords  in der Aktivliste werden gelscht."
	FF_SetControlTooltip "KeyWords","KW Lschen", "" &_
					 	 "In den IPTC-Daten der durch Bilderauswahl gewhlten" & vbNewLine &_
					 	 "Bilder werden alle Keywords gelscht."
	FF_SetControlTooltip "KeyWords","KW Eintragen", "" &_
					 	 "In den IPTC-Daten der durch Bilderauswahl gewhlten Bilder " & vbNewLine &_
					 	 "werden alle Keywords der Aktivliste eingetragen."
	FF_SetControlTooltip "KeyWords","ImageAktiv", "" &_
						 "Aktualisierung mit Mausklick."
	FF_SetControlTooltip "KeyWords","KWvorhanden", "" &_
						 "Im angezeigten Bild gespeicherte Keywords."
	FF_SetControlTooltip "KeyWords","||KW Lschen", "" &_
					 	 "Alle Keywords im angezeigten Bild lschen."
	FF_SetControlTooltip "KeyWords","flag_Loesch", "" &_
					 	 "Wenn aktiviert wird mit Doppelklick auf ein" & vbNewLine &_
					 	 "Keyword in der Liste dieses aus den IPTC-" & vbNewLine &_
					 	 "Daten des angezeigten Bildes entfernt."
	FF_SetControlTooltip "KeyWords","||KW Eintragen", "" &_
					 	 "Alle Keywords der Aktivliste in die IPTC-" & vbNewLine &_
					 	 "Daten des angezeigten Bildes eintragen."
	FF_SetControlTooltip "KeyWords","KW Kopieren", "" &_
						 "Angezeigte Keywords in die Aktivliste kopieren."						 
	FF_SetControlTooltip "KeyWords","Neu", "" &_
					 	 "Je nach gewhltem Ablageort (Liste oder Verzeichnis)" & vbNewLine &_
					 	 "kann eine neue Bilderliste angelegt oder ein Ordner" & vbNewLine &_
					 	 "ausgewhlt werden"
	FF_SetControlTooltip "KeyWords","Backspace", "" &_
					 	 "Mit der Backspace-Taste auf der Tastatur kann eine" & vbNewLine &_
					 	 "laufende Bearbeitung angehalten und nach Rckfrage" & vbNewLine &_
					 	 "fortgesetzt oder abgebrochen werden."
	FF_SetControlTooltip "KeyWords","?", "" &_
					 	 "Anzeige der Kurzbeschreibung als PDF-Dokument." & vbNewLine &_
					 	 "Fehlt die Datei oder ist kein PDF-Reader installiert," & vbNewLine &_
					 	 "wird eine Textkurzfassung gezeigt."
	FF_SetControlTooltip "KeyWords","Update", "" &_
					 	 "Bei bestehender Internetverbindung wird" & vbNewLine &_
					 	 "wird geprft, ob eine neue Version zur" & vbNewLine &_
					 	 "Verfgung steht."
	FF_SetControlTooltip "KeyWords","Schlieen", "" &_
					 	 "Das Skript wird beendet."
	FF_SetControlTooltip "KeyWords","KW Suchen", "" &_
					 	 "In den IPTC-Daten der nach Bilderauswahl gewhlten Bilder " & vbNewLine &_
					 	 "wird nach allen Keywords der Aktivliste gesucht." & vbNewLine &_
					 	 "Je nach gewhlter Option werden die Bilder mit allen" & vbNewLine &_
					 	 "oder mit einem der Keywords in den gewhlten Ablageort" & vbNewLine &_
					 	 "bertragen."						 
end if

if Version_OK("3.40.52") then FF_SetTooltipDelay 4000
FF_ActivateControl "KeyWords","&d"
FF_SetDialogTimer "KeyWords", 100

do
	Abbruch = false

	if SelZaehler <= 1 then 
		FF_EnableControl "KeyWords","||<", false
	else
		FF_EnableControl "KeyWords","||<", true
	end if
	
	if SelZaehler >= SelAnzahl then 
		FF_EnableControl "KeyWords","||>", false
	else
		FF_EnableControl "KeyWords","||>", true
	end if	
	
	if PassivAlt <> PassivListe then PLflag = true			'Inhalt der PassivListe wurde gendert
	
	Select Case FF_ShowDialog ("KeyWords")
	
	Case "&d"
		Abbruch = false
		SkriptKill = false
		Antwort = msgbox("Soll das Skript " & SkriptName & vbNewline & _
						 "mit allen dazugehrigen Komponenten wirklich gelscht werden?", _
						 vbYesNo + vbQuestion,"Sicherheitsabfrage")
		if Antwort = vbYes then
			SkriptKill = true
			exit do
		end if
	Case "TIMER"
		FF_SetControl "KeyWords" ,"|", "V " & Skriptversion
		FF_SetDialogTimer "KeyWords", 0
	Case "Update"											'### Versionsprfung
		if InternetConnection then
			SkriptEnde = false
			call Update
			if SkriptEnde then exit do
		end if
	Case "selBilder"										'### Bilderauswahl
		FF_SetControl "KeyWords","selBilder","1"
		FF_SetControl "KeyWords","allBilder","0"
		FF_SetControl "KeyWords","allBilderUV","0"
	Case "allBilder"
		FF_SetControl "KeyWords","selBilder","0"
		FF_SetControl "KeyWords","allBilder","1"
		FF_SetControl "KeyWords","allBilderUV","0"
	Case "allBilderUV"
		FF_SetControl "KeyWords","selBilder","0"
		FF_SetControl "KeyWords","allBilder","0"
		FF_SetControl "KeyWords","allBilderUV","1"

	Case "ImageAktiv"										'### Einzelbearbeitung
		call EinzelBildBearbeitung (0)
	Case "||<"
		call EinzelBildBearbeitung (-1)
	Case "||>"		
		call EinzelBildBearbeitung (+1)
	Case "KWvorhanden"									'Lschen eines Keyword wenn Flag = 1
		Dim Ausgabe,Ausgabeliste
		if FF_GetControl("KeyWords","flag_Loesch") = 1 and len(KWvorhandenListe) > 0 then
			on error resume next
				FF_LoadImage SelBildAktiv
			on error goto 0
			Eingabe = FF_GetIPTC("Keywords")
			
			if len(Eingabe) > 0 then
				Ausgabe = FF_GetControl("KeyWords","KWvorhanden")
				FF_SetControl "KeyWords","KWvorhanden",""
				KWvorhandenListe = "" : Ausgabeliste = ""
				LInhalt = split(Eingabe, vbNewLine)
				for each Wert in LInhalt
					if Wert <> Ausgabe then
						FF_SetControl "KeyWords","KWvorhanden",Wert
						if len(Ausgabeliste) = 0 then
							Ausgabeliste = Wert
						else
							Ausgabeliste = Ausgabeliste & vbNewLine & Wert
						end if
					end if
				next
				KWvorhandenListe = Ausgabeliste
				FF_SetIPTC "Keywords", ""
				FF_SetIPTC "Keywords", Ausgabeliste
				FF_SaveIPTC SelBildAktiv					
			end if
		end if
	Case "||KW Lschen"									'Lschen aller Keywords
		if len(FF_GetSelection(1)) > 0 then
			on error resume next
				FF_LoadImage SelBildAktiv
			on error goto 0
			FF_SetIPTC "Keywords", ""
			FF_SaveIPTC SelBildAktiv
		else
			FF_SetControl "KeyWords","ImageGeladen","kein Bild geladen"
			FF_SetControl "KeyWords","ImageAktiv",KeinBildD
		end if
		FF_SetControl "KeyWords","KWvorhanden",""
		KWvorhandenListe = ""
	Case "||KW Eintragen"									'Eintragen von Keywords
		if len(FF_GetSelection(1)) > 0 then
			Bild = SelBildAktiv
			if len(AktivListe) > 0 then
				BearbeitungsFlag = 2
				call Bearbeiten
				call Bearbeitungseintrag (SelZaehler - 1)
			else
				msgbox "In der Aktivliste sind keine Schlagworte eingetragen!",vbExclamation,"Hinweis"
			end if
		else
			FF_SetControl "KeyWords","ImageGeladen","kein Bild geladen"
			FF_SetControl "KeyWords","ImageAktiv",KeinBildD
			FF_SetControl "KeyWords","KWvorhanden",""
			KWvorhandenListe = ""
		end if
	Case "KW Kopieren"
		if len(KWvorhandenListe) > 0 then
			LInhalt = split(KWvorhandenListe, vbNewLine)
			for each Wert in LInhalt
				if not GleichCheck (Wert,AktivListe) then
					FF_SetControl "KeyWords","AktivListe",Wert
					AktivListe = AktivListe & vbNewLine & Wert
				end if
			next
		end if
		if left(AktivListe,2) = vbNewLine then AktivListe = mid(AktivListe,3)
	Case "v"												'### Keywords Passivliste
		Eingabe = FF_GetControl("KeyWords","EingbabeKW")
		Eingabe = trim(Eingabe)
		if len(Eingabe) > 0 then
			Eingabe = ucase(Left(Eingabe,1)) & mid(Eingabe,2)
			if not GleichCheck (Eingabe,PassivListe)then
				FF_SetControl "KeyWords","PassivListe",Eingabe
				FF_SetControl "KeyWords","PassivListe",Eingabe
				PassivListe = PassivListe & vbNewLine & Eingabe
				Feldzahl = Feldzahl + 1
			else
				WshShell.popup  "Der eingegebene Begriff existiert bereits!",1,"Information",vbInformation
			end if
			if left(PassivListe,2) = vbNewLine then PassivListe = mid(PassivListe,3)
			
			FF_SetControl "KeyWords","AktivListe",Eingabe
			AktivListe = AktivListe & vbNewLine & Eingabe
			if left(AktivListe,2) = vbNewLine then AktivListe = mid(AktivListe,3)
		end if
		FF_SetControl "KeyWords","EingbabeKW",""
		FF_ActivateControl "KeyWords","EingbabeKW"
	Case "&S"
		Eingabe = FF_GetControl("KeyWords","EingbabeKW")
		Eingabe = trim(Eingabe)
		if len(Eingabe) > 0 then
			LInhalt = split(PassivListe, vbNewLine)
			for each Wert in LInhalt
				if ucase(left(Wert,len(Eingabe))) = ucase(Eingabe) then
					FF_SetControl "KeyWords","PassivListe",Wert
					exit for
				end if
			next
		end if
	Case "Lschen"
		call Loeschen (PassivListe, "PassivListe")
		if Feldzahl > 0 then Feldzahl = Feldzahl - 1
	Case "Alles Lschen"
		FF_SetControl "KeyWords","PassivListe",""
		PassivListe = ""
		Feldzahl = 0
	Case "Speichern"
		if Feldzahl > 1 then 
			Eingabe = FF_GetControl("KeyWords","PassivListe")
			call Sortieren (FeldZahl,PassivListe,"PassivListe")
			FF_SetControl "KeyWords","PassivListe", Eingabe
		end if
		call Speichern
	Case "Restaurieren"
		call Lesen
	Case ">","PassivListe"										'### Austausch Passiv-/Aktivliste
		Eingabe = FF_GetControl("KeyWords","PassivListe")
		if not GleichCheck (Eingabe,AktivListe) then
			FF_SetControl "KeyWords","AktivListe",Eingabe
			AktivListe = AktivListe & vbNewLine & Eingabe
		end if
		if left(AktivListe,2) = vbNewLine then AktivListe = mid(AktivListe,3)
		FF_SetControl "KeyWords","EingbabeKW",""
		FF_ActivateControl "KeyWords","EingbabeKW"
	Case "<","AktivListe"
		Eingabe = FF_GetControl("KeyWords","AktivListe")
		Eingabe = ucase(Left(Eingabe,1)) & mid(Eingabe,2)
		if not GleichCheck (Eingabe,PassivListe) then
			FF_SetControl "KeyWords","PassivListe",Eingabe
			PassivListe = PassivListe & vbNewLine & Eingabe
		end if
		if left(PassivListe,2) = vbNewLine then PassivListe = mid(PassivListe,3)
		call Loeschen (AktivListe, "AktivListe")
	Case "<<"
		LInhalt = split(AktivListe, vbNewLine)
		for each Wert in LInhalt
			Wert = ucase(Left(Wert,1)) & mid(Wert,2)
			if not GleichCheck (Wert,PassivListe) then
				FF_SetControl "KeyWords","PassivListe",Wert
				Feldzahl = Feldzahl + 1
				PassivListe = PassivListe & vbNewLine & Wert
			end if
		next
		if left(PassivListe,2) = vbNewLine then PassivListe = mid(PassivListe,3)
		FF_SetControl "KeyWords","AktivListe",""
		AktivListe = ""
	Case "Sammeln"											'### Keywords Aktivliste
		Antwort = msgbox("Das Sammeln von Keywords kann unter Umstnden" & vbNewLine &_
				 "sehr lange dauern. Soll trotzdem gestartet werden?",vbQuestion + vbYesNo,"Info")
		if Antwort = vbYes then
			call RegistrySchreiben
			FF_SetControl "KeyWords","AktivListe",""
			AktivListe = ""
			FeldZahlAktiv = 0
			BearbeitungsFlag = 0
			call Bilderschleife
			if FeldZahlAktiv > 1 then call Sortieren (FeldZahlAktiv,AktivListe,"AktivListe")
		end if
	Case "|Lschen"
		call Loeschen (AktivListe, "AktivListe")
	Case "|Alles Lschen"
		FF_SetControl "KeyWords","AktivListe",""
		AktivListe = ""
	Case "KW Lschen"
		Antwort = msgbox("Sollen wirklich alle Keywords in den IPTC-Daten gelscht werden?", vbQuestion + vbYesNo,"Frage")
		if Antwort = vbYes then
			call RegistrySchreiben
			BearbeitungsFlag = 1
			call Bilderschleife
			call Bearbeitungseintrag (SelZaehler - 1)
		end if
	Case "KW Eintragen"
		if len(AktivListe) > 0 then
			call RegistrySchreiben
			BearbeitungsFlag = 2
			call Bilderschleife
			call Bearbeitungseintrag (SelZaehler - 1)
		else
			msgbox "In der Aktivliste sind keine Schlagworte eingetragen!",vbInformation,"Information"
		end if
	Case "boolBListe"										'### Keyword-Suche
		FF_SetControl "KeyWords","boolBListe","1"
		FF_SetControl "KeyWords","boolVListe","0"
		FF_SetControl "KeyWords","FundListe",""
		Eingabe = ""
		call Bilderliste	
	Case "boolVListe"
		FF_SetControl "KeyWords","boolBListe","0"
		FF_SetControl "KeyWords","boolVListe","1"
		FF_SetControl "KeyWords","FundListe",""
		Eingabe = ""
		call Verzeichnisliste
	Case "FundListe"
		BildListeAktiv = FF_GetControl("KeyWords","FundListe")
	Case "Neu"
		call RegistrySchreiben
		LVorhanden = false
		if BilderListenWert = "1" then
			Eingabe = InputBox("Namen einer neuen Bilderliste eingeben!")
			if len(Eingabe) > 0 then
				Eingabe = Ucase(left(Eingabe,1)) & mid(Eingabe,2)
				call Bilderliste
			end if
		else
			Eingabe = FF_EnterPath(false,"Verzeichnis whlen!")
			call Verzeichnisliste
		end if
		if len(Eingabe) > 0 and not LVorhanden then
			BildListeAktiv = Eingabe
			FF_SetControl "KeyWords","FundListe",Eingabe
			FF_SetControl "KeyWords","FundListe",Eingabe
			if BilderListenWert = "1" then FF_IListCreate Eingabe
			if BilderListenWert = "0" then
				if not objFs.FolderExists(Eingabe) then objFs.CreateFolder(Eingabe)
				FF_IPathCreate Eingabe, Eingabe
			end if
			FF_IListSave Eingabe
		else
			if LVorhanden then msgbox "Die Liste ist bereits vorhanden!",vbInformation,"Hinweis"
		end if
	Case "boolSucheUnd"
		FF_SetControl "KeyWords","boolSucheUnd","1"
		FF_SetControl "KeyWords","boolSucheOder","0"
	Case "boolSucheOder"
		FF_SetControl "KeyWords","boolSucheUnd","0"
		FF_SetControl "KeyWords","boolSucheOder","1"		
	Case "KW Suchen"
		if len(AktivListe) > 0 and len(BildListeAktiv) > 0 then
			Antwort = msgbox("Das Suchen von Keywords kann unter Umstnden" & vbNewLine &_
				 	"sehr lange dauern. Soll trotzdem gestartet werden?",vbQuestion + vbYesNo,"Info")
			if Antwort = vbYes then
				call RegistrySchreiben
				BearbeitungsFlag = 3
				call Bilderschleife
				FF_IListUpdate BildListeAktiv
			end if
		elseif len(AktivListe) = 0 then
			msgbox "In der Aktivliste sind keine Schlagworte eingetragen!",vbInformation,"Information"
		elseif len(BildListeAktiv) = 0 then
			msgbox "Es muss eine Bilderliste oder eine Verzeichnisliste angezeigt werden!",vbExclamation,"Hinweis"	
		end if
	Case "?"												'### Allgemeine Befehle
		'FF_SetControl "KeyWords","Fortschritt",65			'Screenshot
		on error resume next
		WshShell.Run chr(34) & FF_GetScriptPath & "\MeckiScript\KeyWords\KeyWords.pdf" & chr(34),1,false
		if err <> 0 then
			msgbox "Die Kurzbeschreibung konnte nicht als PDF-Datei" & vbNewLine & _
				   "geffnet werden." & vbNewLine & _
				   "Die Datei ist gelscht oder es ist kein PDF-" & vbNewLine & _
				   "Reader installiert (?)." & vbNewLine & vbNewLine &_
				   "Ersatzweise erfolgt eine Textanzeige!",vbExclamation,"Hinweis"
			err.clear
			if not KBvorhanden then	call KurzbeschreibungLesen
			if KBvorhanden then
				call KurzbeschreibungAnzeigen
			else
				msgbox "Keine Kurzbeschreibung gefunden!",vbExclamation,"Hinweis"
			end if
		end if
		on error goto 0
	Case "Schlieen", "CANCEL"
		call RegistrySchreiben
		if PLflag then
			Antwort = msgbox("Der Inhalt der Passivliste wurde gendert." & vbNewLine & _
							 "Soll er gesichert werden ?",vbYesNo or vbQuestion,"Sicherheitsabfrage")
			if Antwort = vbYes then
				if Feldzahl > 1 then 
					Eingabe = FF_GetControl("KeyWords","PassivListe")
					call Sortieren (FeldZahl,PassivListe,"PassivListe")
					FF_SetControl "KeyWords","PassivListe", Eingabe
				end if
				call Speichern
			end if
		end if
		exit sub
	Case Else
	End Select
loop

FF_CloseDialog ("KeyWords")
if SkriptKill then call KillSkript	'ggf. Skript komplett entfernen

End Sub
'------------------------------------------------------------------------
Sub Bilderschleife

'### Bilder nacheinander laden
'Auswahl(): 0 = selekt., 1 = alle, 2 = alle inc. UVz.

Set objFolder = objFS.GetFolder(FF_GetImagePath())				'aktiver Ordner

if Auswahl(0) = "1" then										'selektierte Bilder

	if len(FF_GetSelection(1)) = 0 then
		Antwort = msgbox("Es wurde kein(e) Bild(er) ausgewhlt." & vbNewLine & _
		"Es werden in alle Bilder des aktiven Verzeichnis (o. UVerz.) bearbeitet.",vbOkCancel or vbQuestion,"Abfrage")
		if Antwort = vbCancel then 
			exit sub
		else
			Auswahl(0) = "0"	'selekt. Bilder
			Auswahl(1) = "1"	'alle Bilder
		end if
	end if
end if

call BilderAnzahl	'Bestimmung der Dateienanzahl fr die Fortschrittsanzeige

'Schleife
Anzahl = 0 : Fundzahl = 0
	if Auswahl(0) = "1" or Auswahl(1) = "1" then			'selektierte oder alle Bilder
		for each Bild in ListeBilder
			Anzahl = Anzahl + 1								'Bilder zhlen
			FF_SetControl "KeyWords","Fortschritt",Anzahl/Gesamtanzahl*100
			'### Abbruch?
			if FF_CheckKey() = 8 then 	'8 = Backspace
				Antwort = msgbox("Von " & Gesamtanzahl & " Dateien wurden bisher " & Anzahl & _
					 			" Bilder bearbeitet." & vbNewLine & vbNewLine & _
					 			"Soll die Bearbeitung abgebrochen werden?",vbYesNo or vbQuestion,"Abfrage")
				if Antwort = vbYes then 
					Abbruch = true
					exit sub
				end if
			end if
			call Bearbeiten
		next
	else										'alle Bilder exclus. und incl. Untervz.
		call ShowSubfolder (objFolder)
	end if
	
	if BearbeitungsFlag = 3 then
		msgbox "Fertig!" & vbNewLine &_
			   "Es wurden " & Anzahl & " Dateien bearbeitet." & vbNewLine &_
			   Fundzahl & " Bilder mit bereinstimmungen wurden gefunden.",vbInformation,"Info"
	else
		msgbox "Fertig!" & vbNewLine &_
			   "Es wurden " & Anzahl & " Dateien bearbeitet.",vbInformation,"Info"
	end if
	FF_SetControl "KeyWords","Fortschritt",0
	
End Sub
'------------------------------------------------------------------------
Sub RegistryLesen
'Schlsselname = HKEY_CURRENT_USER\Software\Joachim Koopmann Software\FixFoto\Script\KeyWords

'Werte auslesen
AuswahlWert = FF_GetProfile("KeyWords","Auswahl")
if AuswahlWert = "" then AuswahlWert = "1/0/0"

SuchUndWert = FF_GetProfile("KeyWords","SuchUndWert")
if SuchUndWert = "" then SuchUndWert = "1"

BilderListenWert = FF_GetProfile("KeyWords","BilderListenWert")
if BilderListenWert = "" then BilderListenWert = "1"

flag_Loesch = FF_GetProfile("KeyWords","flag_Loesch")
if flag_Loesch = "" then flag_Loesch = "0"

'Werte eintragen
AuswahlWert = split(AuswahlWert,"/",-1)
FF_SetControl "KeyWords","selBilder",AuswahlWert(0)
FF_SetControl "KeyWords","allBilder",AuswahlWert(1)
FF_SetControl "KeyWords","allBilderUV",AuswahlWert(2)
if SuchUndWert = "0" then
	FF_SetControl "KeyWords","boolSucheUnd","0"	
	FF_SetControl "KeyWords","boolSucheOder","1"
else
	FF_SetControl "KeyWords","boolSucheUnd","1"	
	FF_SetControl "KeyWords","boolSucheOder","0"
end if

if BilderListenWert = "0" then
	FF_SetControl "KeyWords","boolBListe","0"	
	FF_SetControl "KeyWords","boolVListe","1"
else
	FF_SetControl "KeyWords","boolBListe","1"	
	FF_SetControl "KeyWords","boolVListe","0"
end if

FF_SetControl "KeyWords","flag_Loesch",flag_Loesch
	
End Sub
'------------------------------------------------------------------------
Sub RegistrySchreiben
'Schlsselname = HKEY_CURRENT_USER\Software\Joachim Koopmann Software\FixFoto\Script\KeyWords

Auswahl(0) = FF_GetControl("KeyWords","selBilder")
Auswahl(1) = FF_GetControl("KeyWords","allBilder")
Auswahl(2) = FF_GetControl("KeyWords","allBilderUV")
FF_WriteProfile "KeyWords","Auswahl",Auswahl(0) & "/" & Auswahl(1) & "/" & Auswahl(2)

BilderListenWert = FF_GetControl("KeyWords","boolBListe")
FF_WriteProfile "KeyWords","BilderListenWert",BilderListenWert

SuchUndWert = FF_GetControl("KeyWords","boolSucheUnd")
FF_WriteProfile "KeyWords","SuchUndWert",SuchUndWert

flag_Loesch = FF_GetControl("KeyWords","flag_Loesch")
FF_WriteProfile "KeyWords","flag_Loesch",flag_Loesch

End Sub
'------------------------------------------------------------------------
Sub ShowSubfolder(ByVal myfolder)
'Ermittlung der Bilder in den Unterordnern
Dim strExt

	For Each Bild In myfolder.Files
			
		Anzahl = Anzahl + 1
		FF_SetControl "KeyWords","Fortschritt",Anzahl/Gesamtanzahl*100	'Fortschrittsanzeige
			
		strExt = objFS.GetExtensionName(Bild.Name) 		'Datei-Extension ermitteln
		
		if instr(Ucase(BildKenn), Ucase(strExt)) > 0 then
'### Abbruch?
if FF_CheckKey() = 8 then 	'8 = Backspace
	Antwort = msgbox("Von " & Gesamtanzahl & " Dateien wurden bisher " & Anzahl & _
					 " Bilder bearbeitet." & vbNewLine & vbNewLine & _
					 "Soll die Bearbeitung abgebrochen werden?",vbYesNo or vbQuestion,"Abfrage")
	if Antwort = vbYes then 
		exit sub
	end if
end if
			call Bearbeiten
		end if
	next

For Each objsubfolder In myfolder.subfolders
	ShowSubfolder objSubFolder
Next
	
End Sub
'------------------------------------------------------------------------
Sub BilderAnzahl
'Ermittlung der Gesamtanzahl Bilder

Gesamtanzahl = 0

if Auswahl(0) = "1" then 
	Bilder = FF_GetSelection(1)			'0 = alle Dateien der Computeransicht
										'1 = alle selektierten Dateien der Computeransicht
										'2 = alle Dateien der aktuellen Bilderliste
										'3 = alle selektierten Dateien der aktuellen Bilderliste
elseif Auswahl(1) = "1" then
	Bilder = FF_GetSelection(0)
elseif Auswahl(2) = "1" then
	ZaehlerSub (objFolder)
	exit sub
end if

ListeBilder = split(Bilder, vbNewLine)
Gesamtanzahl = ubound(ListeBilder) + 1

End Sub
'------------------------------------------------------------------------
Sub ZaehlerSub(ByVal myfolder)
'Zhlen der Ordner, Unterordner und Dateien

Gesamtanzahl = Gesamtanzahl + myfolder.files.count	'Anzahl Dateien

For Each objSubFolder In myfolder.subfolders
     ZaehlerSub (objSubFolder)
Next

End sub
'------------------------------------------------------------------------
Sub Loeschen (Inhalt, Liste)
'markierten Wert aus dem String Inhalt und aus der Liste lschen

Dim Loeschwert

LoeschWert = FF_GetControl("KeyWords",Liste)
LInhalt = split(Inhalt, vbNewLine)
FF_SetControl "KeyWords",Liste,""
Inhalt = ""
for each Wert in LInhalt
	if LoeschWert <> Wert and len(Wert) >0 then
		FF_SetControl "KeyWords",Liste,Wert
		Inhalt = Inhalt & vbNewLine & Wert
	end if
next
if left(Inhalt,2) = vbNewLine then Inhalt = mid(Inhalt,3)

End Sub
'------------------------------------------------------------------------
Function GleichCheck (ByVal AddWert, ByVal Inhalt)
'Wert vergleichen mit Inhalt

Dim XInhalt, XWert
GleichCheck = False
AddWert = ucase(AddWert)

XInhalt = split(Inhalt, vbNewLine)
for each XWert in XInhalt
	if AddWert = ucase(XWert) then
		Eingabe = XWert
		GleichCheck = True
		exit Function
	end if
next

End Function
'------------------------------------------------------------------------
Sub Sortieren (Zahl,Liste,ZielListe)
'Sortieren der Liste mit 'Zahl' Elemente in die ZieListe

Dim n

'Feld-Array fllen
Redim Feld(Zahl)
LInhalt = split(Liste, vbNewLine)
n = 0
for each Wert in LInhalt
	Feld(n) = Wert
	n = n + 1
next

'Sortierung aufrufen
Call QuickSort(LBound(Feld), UBound(Feld))

'sortiertes Feld einschreiben in die ZielListe
FF_SetControl "KeyWords",ZielListe,""
Liste = ""

for n = 0 to Zahl
	if len(Feld(n)) > 0 then
		FF_SetControl "KeyWords",ZielListe,Feld(n)
		Liste = Liste & vbNewLine & Feld(n)
	end if
next
if left(Liste,2) = vbNewLine then Liste = mid(Liste,3)

'Feld lschen
Erase Feld

End Sub
'------------------------------------------------------------------------
Sub QuickSort(ByVal LB, ByVal UB)
'Sortieren des Arrays 'Feld'

Dim P1, P2, Ref, TEMP

P1 = LB
P2 = UB
Ref = Feld((P1 + P2) / 2)
  
Do
	Do While Feld(P1) < Ref
    	P1 = P1 + 1
	Loop
 
	Do While Feld(P2) > Ref
    	P2 = P2 - 1
	Loop

	If P1 <= P2 Then
    	TEMP = Feld(P1)
        Feld(P1) = Feld(P2)
        Feld(P2) = TEMP
           
        P1 = P1 + 1
        P2 = P2 - 1
	End If
Loop Until P1 > P2

If LB < P2 Then Call QuickSort(LB, P2)
If P1 < UB Then Call QuickSort(P1, UB)

End Sub
'------------------------------------------------------------------------
Sub Speichern
'Abfrage, ob Dateiinhalt wirklich gelscht werden soll
if len(Passivliste) = 0 then
	Antwort = msgbox("Das Speichern einer leeren Liste lscht die Schlsselwortdatei." & vbNewLine & _
					 "Soll sie wirklich gelscht werden?" & vbNewLine & vbNewLine & _
					 "Wenn Nein, kann sie mit Restaurieren wieder hergestellt werden.",vbYesNo or vbDefaultButton2 or vbQuestion,"Sicherheitsabfrage")
	if Antwort = vbNo then exit sub
end if

'PLflag True bedeutet, die PassiListe wurde gendert
PassivAlt = PassivListe
PLflag = False

'PassivListe der Keywords in eine Datei speichern
if left(PassivListe,2) = vbNewLine then	PassivListe = mid(PassivListe,3)
Set KeyWordDatei = objFS.OpenTextFile(DateiName, ForWriting, true)
KeyWordDatei.Write PassivListe
KeyWordDatei.Close

End Sub
'------------------------------------------------------------------------
Sub Lesen
'PassivListe der Keywords auslesen und diese in die Passivliste eintragen

on error resume next
'Auslesen
Set KeyWordDatei = objFS.OpenTextFile(DateiName, ForReading, true)
PassivListe = KeyWordDatei.ReadAll
KeyWordDatei.Close
if Err.Number > 0 then err.clear : exit sub
On Error GoTo 0

'Eintragen
FF_SetControl "KeyWords","PassivListe",""
Feldzahl = 0

LInhalt = split(PassivListe, vbNewLine)
for each Wert in LInhalt
	FF_SetControl "KeyWords","PassivListe",Wert
	Feldzahl = Feldzahl + 1
next

PassivAlt = PassivListe
PLflag = False

End Sub
'------------------------------------------------------------------------
Sub Bearbeiten
'BearbeitungsFlag: 0= Sammeln, 1= Lschen, 2= Eintragen, 3= Suchen

Dim IPTC_Date, Fund, IPTCstring

on error resume next
	FF_LoadImage Bild
on error goto 0

Eingabe = FF_GetIPTC("Keywords")

select case BearbeitungsFlag
case 0	'Sammeln
	if len(Eingabe) > 0 then
		LInhalt = split(Eingabe, vbNewLine)
		for each Wert in LInhalt
			if not GleichCheck (Wert,AktivListe) then
				FF_SetControl "KeyWords","AktivListe",Wert
				AktivListe = AktivListe & vbNewLine & Wert
				FeldZahlAktiv = FeldZahlAktiv + 1
			end if
		next
		if left(AktivListe,2) = vbNewLine then AktivListe = mid(AktivListe,3)
	end if
case 1	'Lschen
	FF_SetIPTC "Keywords", ""
	FF_SaveIPTC Bild
case 2	'Eintragen
	IPTC_Date = AktivListe
	LInhalt = split(Eingabe, vbNewLine)
	for each Wert in LInhalt
		if not GleichCheck (Wert,AktivListe) then
			IPTC_Date = IPTC_Date & vbNewLine & Wert
		end if
	next
	FF_SetIPTC "Keywords", IPTC_Date
	FF_SaveIPTC Bild
case 3	'Suchen
	'vorhandene IPTC-Daten holen und vergleichen mit Aktivliste
	Fund = False
	if FF_HasIPTC() then
		Eingabe = FF_GetIPTC("Keywords")
		if len(Eingabe) > 0 then
		
			LInhalt = split(Eingabe, vbNewLine)		'IPTC holen
			for each Wert in LInhalt
				IPTCstring = IPTCstring & Wert & "|"
			next
			IPTCstring = ucase("|" & IPTCstring)
			
			LInhalt = split(AktivListe, vbNewLine)	'Vergleich mit Aktivliste
			for each Wert in LInhalt
				Wert = ucase("|" & Wert & "|")
				if instr(IPTCstring, Wert) > 0 then
					Fund = True
					if SuchUndWert = "0" then exit for	'*** Oder
				else
					Fund = False
					if SuchUndWert = "1" then exit for	'*** Und	
				end if
			next
			
		else
			Fund = False
		end if
	else
		Fund = False
	end if
	
	'Gefundenes Bild in Bilderliste eintragen
	if Fund then
		Fundzahl = Fundzahl +1
		if BilderListenWert = "1" then
			FF_IListInsertFile BildListeAktiv, Bild, -1
		else
			objFs.CopyFile Bild, BildListeAktiv & "\" , True
			FF_IListUpdate BildListeAktiv
		end if
	end if
	
case else
	msgbox "Case-Fehler / Sub Bearbeiten"
end select

End Sub
'------------------------------------------------------------------------
Sub EinzelBildBearbeitung (ByVal Weiter)

if SelBilder = FF_GetSelection(1) and len(FF_GetSelection(1)) > 0 then
	SelZaehler = SelZaehler + Weiter
	if  SelZaehler > 0 and SelZaehler <= SelAnzahl then
		call Bearbeitungseintrag (SelZaehler - 1)
	else
		SelZaehler = SelZaehler - Weiter
	end if
else
	SelBilder = FF_GetSelection(1)
	
	if len(SelBilder) = 0 then 						'keine Bilder selektiert
		FF_SetControl "KeyWords","ImageGeladen","kein Bild geladen"
		FF_SetControl "KeyWords","ImageAktiv",KeinBildD
		FF_SetControl "KeyWords","KWvorhanden",""
		KWvorhandenListe = ""
		exit sub
	end if
	
	SelZaehler = 1
	SelListeBilder = split(SelBilder, vbNewLine)
	SelAnzahl = ubound(SelListeBilder) + 1
	call Bearbeitungseintrag (0)
end if

End Sub
'------------------------------------------------------------------------
Sub Bearbeitungseintrag (ByVal Kennung)
Dim NameGeladen

if Kennung < 0 then exit sub
FF_SetControl "KeyWords","KWvorhanden",""		'Liste der Keywords lschen
KWvorhandenListe = ""

SelBildAktiv = SelListeBilder(Kennung)
on error resume next
	FF_LoadImage SelBildAktiv
on error goto 0

'Geladenes Bild anzeigen
Pos = instrrev(SelBildAktiv,"\")
if Pos > 0 then 
	NameGeladen = mid(SelBildAktiv, Pos+1)
	FF_SetControl "KeyWords","ImageGeladen",NameGeladen
	FF_SetControl "KeyWords","ImageAktiv",SelBildAktiv
end if

'vorhandene Keywords anzeigen
if FF_HasIPTC() then
	KWvorhandenListe = FF_GetIPTC("Keywords")

	if len(KWvorhandenListe) > 0 then
		LInhalt = split(KWvorhandenListe, vbNewLine)
		for each Wert in LInhalt
			FF_SetControl "KeyWords","KWvorhanden",Wert
		next
	end if
end if

End Sub
'------------------------------------------------------------------------
Sub Bilderliste
'Eintrag vorhander Bilderlisten

if len(FF_IListGetLists()) = 0 then exit sub
LInhalt = split(FF_IListGetLists(), vbNewLine)
for each Wert in LInhalt
	if len(Eingabe) > 0 then
		if ucase(Eingabe) = ucase(Wert) then 
			LVorhanden = true
			Eingabe = Wert
			exit sub
		end if
	else
		FF_SetControl "KeyWords","FundListe",Wert
	end if
next
BildListeAktiv = LInhalt(0)

End Sub
'------------------------------------------------------------------------
Sub Verzeichnisliste
'Eintrag vorhander Verzeichnislisten

if len(FF_IPathGetLists()) = 0 then exit sub

LInhalt = split(FF_IPathGetLists(), vbNewLine)
for each Wert in LInhalt
	if len(Eingabe) > 0 then
		if ucase(Eingabe) = ucase(Wert) then 
			LVorhanden = true
			exit sub
		end if
	else
		FF_SetControl "KeyWords","FundListe",Wert
	end if
next
BildListeAktiv = LInhalt(0)

End Sub
'------------------------------------------------------------------------
Sub KurzbeschreibungLesen
on error resume next
Const ForReading = 1
Dim Skript, Anfang, Ende, Zeile

'setzt voraus:
'Set objFS = CreateObject("Scripting.FileSystemObject")			'FileSytemObject

Set Skript = objFS.OpenTextFile(FF_GetScriptPath & "\" & SkriptName, ForReading, False)

if err.number = 53 then
	msgbox "Wahrscheinlich wurde der Originalskriptname " & """" & SkriptName & """" & " abgendert." & vbNewLine & _
		   "Die Kurzbeschreibung kann daher nicht angezeigt werden.",vbExclamation,"Meldung"
	Abbruch = True
	exit sub
end if

Do While Skript.AtEndOfStream <> True
	Zeile = Skript.ReadLine
	
	if instr(Zeile,"** Ende Kurzbeschreibung") > 0 then Ende = true
	if Ende then exit do
	
	if Anfang then Kurzbeschreibung = Kurzbeschreibung & mid(Zeile,2) & vbNewLine
	if len(Zeile)-1 > LaengeMax then LaengeMax = len(Zeile)-1
	
	if instr(Zeile,"** Start Kurzbeschreibung") > 0 then Anfang = true
	
Loop
	
if Anfang and Ende then KBvorhanden = true
Skript.Close

End Sub
'------------------------------------------------------------------------
Sub KurzbeschreibungAnzeigen

Dim Taste

Dim Breite	: Breite = LaengeMax * 2.6 + 5
const Hoehe = 180

const ES_READONLY = 2048
const WS_VSCROLL = 2097152

FF_AddDialog "Kurzbeschreibung",Breite,Hoehe
FF_AddControl "Kurzbeschreibung","Beschreibung","EDIT",0,0,Breite,Hoehe-20
FF_SetControlStyle "Kurzbeschreibung","Beschreibung", ES_READONLY + WS_VSCROLL
FF_AddControl "Kurzbeschreibung","OK","BUTTON",Breite/2-15,Hoehe-15,30,10

FF_SetControl "Kurzbeschreibung","Beschreibung",Kurzbeschreibung

do
	Taste = FF_ShowDialog("Kurzbeschreibung")
	if Taste = "CANCEL" or Taste = "OK" then exit do
loop
call FF_CloseDialog("Kurzbeschreibung")

End Sub
'------------------------------------------------------------------------
Sub KillSkript
'Skript mit allen Komponenten entfernen

Dim SPfad,msg
const RegSchluessel = "\KeyWords\"

'### FixFotoScript.ini bereinigen
TempFile = FF_GetFFPathEx(1) & "\FixFotoScript.ini"
if objFS.FileExists(TempFile) then
	call IniBereinigung
	if Abbruch then exit sub
else
	msgbox 	"Die Datei FixFotoScript.ini konnte nicht gefunden werden." & vbNewLine & _
			"Der Lschvorgang wird abgebrochen!",vbExclamation,"Hinweis"
	exit sub
end if

'### zip-Archiv auf Wunsch sichern, dann lschen
TempFile = FF_GetScriptPath & "\" & objFS.GetBaseName(Skriptname) & ".zip"
if objFS.FileExists(TempFile) then
	Antwort = msgbox("Soll das Archiv " & objFS.GetBaseName(Skriptname) & ".zip" & _
			 " gesichert werden?",vbYesNo + vbQuestion,"Sicherheitskopie")
	if Antwort = vbYes then
		SPfad = FF_EnterPath(true,"Wo soll die Sicherheitskopie angelegt werden?")
		if SPfad = "" then
			msgbox "Das Lschen des Skripts wird abgebrochen!",vbExclamation,"Hinweis"
			exit sub
		end if
		SPfad = SPfad & "\" & objFS.GetBaseName(Skriptname) & ".zip"
		objFS.CopyFile Tempfile, SPfad, true
	end if
	objFS.DeleteFile TempFile,true
end if

'### Skriptdatei lschen
TempFile = FF_GetScriptPath & "\" & Skriptname
objFS.DeleteFile TempFile,true

'### evtl. beigepackte bzw. erzeugte Dateien und Ordner lschen
TempFile = KeinBildD									'Bild
if objFS.FileExists(TempFile) then objFS.DeleteFile TempFile,true

TempFile = FF_GetScriptPath & "\KeyWords_IPTC.txt"		'KeyWord-Sammlung
if objFS.FileExists(TempFile) then
	Antwort = msgbox("Soll auch die KeyWord-Sammeldatei" & vbNewLine & _
					 "KeyWords_IPTC.txt gelscht werden?",vbYesNo + vbQuestion,"Sicherheitsabfrage")
	if Antwort = vbYes then
		objFS.DeleteFile TempFile,true
		msg = " mit allen Komponenten gelscht!"
	else
		msg = " mit allen Komponenten, auer der KeyWord-Sammeldatei, gelscht!"
	end if
end if

TempFile = FF_GetScriptPath & "\MeckiScript\Keywords"	'Ordner
if objFS. FolderExists (TempFile) then objFS. DeleteFolder TempFile,true

'### Registry-Daten lschen
TempFile = "HKEY_CURRENT_USER\Software\Joachim Koopmann Software\FixFoto\Script" & RegSchluessel
WshShell.RegDelete(TempFile)

'### Fertigmeldung
msgbox "Nach Durchfhrung der 'Automatischen Skriptkonfiguration' ist das Skript" & vbNewLine & _
		Skriptname & msg,vbExclamation,"Hinweis"
End Sub
'------------------------------------------------------------------------
Sub IniBereinigung
'FixFotoScript.ini - Bereinigung

Dim Zeile, zNr,Anfang, Ende, DateiTmp, ZielZeile, tmpString
DateiTmp =  FF_GetFFPathEx(1) & "\FixFotoScript.tmp"

'### Wo befindet sich der Eintrag zum Skript?
Set Zeile = objFS.OpenTextFile(TempFile, ForReading)

zNr = 0
do Until Zeile.AtEndOfStream
	tmpString = Zeile.ReadLine
	zNr = zNr + 1
	if tmpString = "[Script]" then Anfang = zNr
	if tmpString = "File=.\" & Skriptname then
		Ende = zNr
		exit do	
	end if
loop 
Zeile.Close

if Ende <= Anfang then
	msgbox 	"Die Datei FixFotoScript.ini konnte nicht bereinigt werden." & vbNewLine & _
		"Der Lschvorgang wird abgebrochen!",vbExclamation,"Hinweis"
	Abbruch = true
	exit sub
end if

'### Zeilen ohne skriptbezogene Zeilen in DateiTmp bertragen
Set Zeile = objFS.OpenTextFile(TempFile, ForReading)
Set ZielZeile  = objFS.CreateTextFile(DateiTmp, True)

zNr = 0
do Until Zeile.AtEndOfStream
	tmpString = Zeile.ReadLine
	zNr = zNr + 1
	if zNr < Anfang or zNr > Ende then
		ZielZeile.WriteLine tmpString
	end if
loop 

Zeile.Close
ZielZeile.Close

'### Umkopieren von DateiTmp nach FixFotoScript.ini (TempFile)
objFS.CopyFile DateiTmp, TempFile, True
objFS.DeleteFile (DateiTmp)

End Sub
'------------------------------------------------------------------------
'************************************************************************
'FF-Version prfen
'************************************************************************
'------------------------------------------------------------------------
Function Version_OK(MinVersion)
dim VersNr

 VersNr=split(MinVersion,".")
 Version_OK=FF_GetMajor * 1000 + FF_GetMinor + FF_GetBuild / 1000 >=_
     		VersNr(0) * 1000 + VersNr(1) + VersNr(2) / 1000

End Function
'------------------------------------------------------------------------
'************************************************************************
'Update-Funktion
'************************************************************************
Function InternetConnection
 
Dim obj
Set obj = GetObject("winmgmts:Win32_PingStatus.address='" & "google.de" & "'")

if IsNull(obj.StatusCode) or obj.StatusCode <> 0 Then
   msgbox "Keine Internetverbindung!",vbInformation,"Hinweis"
   InternetConnection = false
else
   InternetConnection = true
end if
 
End Function
'------------------------------------------------------------------------
Sub Update
Dim Antwort

call Versionsermittlung_url

if not Abbruch then
	SkriptV_Zahl = Replace(SkriptVersion,".","") *1
	
	if UrlV_Zahl = SkriptV_Zahl then
		msgbox "Die Version " & SkriptVersion & " ist aktuell!",vbInformation,"Versionsmeldung"
	elseif SkriptV_Zahl < UrlV_Zahl then
		Antwort = msgbox("Die Skriptversion " & SkriptVersion & " ist nicht mehr aktuell!" & vbNewLine &_
				"Es steht die Version " & UrlVersion & " zum Download bereit." & vbNewLine & vbNewLine &_
				"Soll die Downloadseite aufgerufen werden?",vbQuestion + vbYesNo,"Versionsmeldung")
		if Antwort = vbYes then
			on error resume next
			WshShell.Run SkriptUrl,1,false
			if err <> 0 then
				msgbox "Die Downloadseite wurde nicht gefunden!",vbExclamation,"Hinweis"
			else
				SkriptEnde = true
			end if
			on error goto 0
		end if
	else
		msgbox 	"Es liegt ein Fehler in den Versionsangaben vor." & vbNewLine &_
				"Die Skriptversion " & SkriptVersion & " ist grer als die auf" & vbNewLine &_
				"der Downloadseite angegebene Version " & UrlVersion & ".",vbInformation,"Fehlermeldung"
	end if
end if

End Sub
'------------------------------------------------------------------------
Sub Versionsermittlung_url

Dim Inhalt,Start,Zeit,pos1,pos2,n
Dim xml, Fehler
Fehler = false

on error resume next
Set xml = CreateObject("Microsoft.XMLHTTP")
xml.Open "Get",SkriptUrl,false
xml.Send

Inhalt = xml.responseText

if err > 0 then
	Fehler = true
else
	'Version suchen und anzeigen
	pos1 = instr(Inhalt,"Version:")
	if pos1 > 0 then
	
		pos2 = instr(pos1 ,Inhalt,"<br")
		if pos2 > 0 then
			UrlVersion = trim(mid(Inhalt,pos1,pos2-pos1))
			'Msgbox "Aktuell ist die " & UrlVersion,vbInformation,"Information"
		else
			Fehler = true
		end if
	else
		Fehler = true
	end if
end if

Set xml = nothing

if Fehler then
	msgbox  "Die Versionsangabe wurde nicht gefunden!" & vbNewLine &_
			"Mglicherweise funktioniert der Internetaufruf nicht." & vbNewLine & vbNewLine & _
			"Am besten nochmal probieren!",vbExclamation,"Fehlermeldung"
	Abbruch = true
	exit sub
end if

'Version als Zahl
pos1 = instr(UrlVersion," ")
if pos1 = 0 then pos1 = 7
UrlVersion = trim(mid(UrlVersion,pos1+1))
UrlV_Zahl = Replace(UrlVersion,".","") *1

End Sub
'------------------------------------------------------------------------
